/*Filename: lake.cpp*/

#include <iostream>
#include "lake.h"

using namespace std;

Lake::Lake(const int l)
{
	length = l;
}

int Lake::get_length()
{
	return length;
}

void Lake::performance(List& main_queue)
{
	int curr = 1; //deiktis trexousas stoivas
	
	cout << "\nMoving Iceskaters to the corners of the Lake...\n" << endl;

	while (!main_queue.is_empty())
	{
		while (true)
		{
			//an einai i seira tis protis-kato arisrtera stoivas gia topothetisi
			if (curr == 1)
			{
                //an i trexousa stoiva einai keni i sto telos tis yparxei kapoios me diaforetiko xroma apo ton proto tis vasikis ouras
				if (lowerLeftStack.is_empty() ||
			        main_queue.get_first_data()->get_color() != lowerLeftStack.get_last_data()->get_color())
			    {
					//metaferei ton proto tis vasikis ouras sto telos tis trexousas stoivas
	                cout << "Adding IceSkater " << main_queue.get_first_data()->get_id() << " to the LowerLeftStack" << endl;
	                cout << "Deleting IceSkater " << main_queue.get_first_data()->get_id() << " from the MainQueue" << endl;
                    lowerLeftStack.insert_at_end(main_queue.extract_from_start());
                    curr++; //auxanei ton deikti trexousas stoivas
                    break; //paei ston epomeno an yparxei
				}
				else
				{
					curr++; //allios dokimazei stin epomeni stoiva
				}
			}
			//omoios an einai i seira tis deuteris-kato deksia stoivas gia topothetisi
			else if (curr == 2)
			{
				if (lowerRightStack.is_empty() ||
			        main_queue.get_first_data()->get_color() != lowerRightStack.get_last_data()->get_color())
			    {
	                cout << "Adding IceSkater " << main_queue.get_first_data()->get_id() << " to the LowerRightStack" << endl;
	                cout << "Deleting IceSkater " << main_queue.get_first_data()->get_id() << " from the MainQueue" << endl;
                    lowerRightStack.insert_at_end(main_queue.extract_from_start());
                    curr++;
                    break;
				}
				else
				{
					curr++;
				}
			}
			//omoios an einai i seira tis tritis-pano deksia stoivas gia topothetisi
			else if (curr == 3)
			{
				if (upperRightStack.is_empty() ||
			        main_queue.get_first_data()->get_color() != upperRightStack.get_last_data()->get_color())
			    {
	                cout << "Adding IceSkater " << main_queue.get_first_data()->get_id() << " to the UpperRightStack" << endl;
	                cout << "Deleting IceSkater " << main_queue.get_first_data()->get_id() << " from the MainQueue" << endl;
                    upperRightStack.insert_at_end(main_queue.extract_from_start());
                    curr++;
                    break;
				}
				else
				{
					curr++;
				}
			}
			//omoios an einai i seira tis tetartis-pano aristera stoivas gia topothetisi
			else
			{
				if (upperLeftStack.is_empty() ||
			        main_queue.get_first_data()->get_color() != upperLeftStack.get_last_data()->get_color())
			    {
	                cout << "Adding IceSkater " << main_queue.get_first_data()->get_id() << " to the UpperLeftStack" << endl;
	                cout << "Deleting IceSkater " << main_queue.get_first_data()->get_id() << " from the MainQueue" << endl;
                    upperLeftStack.insert_at_end(main_queue.extract_from_start());
                    curr = 1;
                    break;
				}
				else
				{
					curr = 1;
				}
			}
		}
	}

	int sk_num, empty = 0;
	IceSkater* temp_icsk = NULL;
	
	cout << "\nStarting performance...\n" << endl;

	//oso den einai kai oi 4 stoives kenes
	while (empty < 4)
	{
		//tis tsekarei mia-mia me tin seira
		if (!lowerLeftStack.is_empty())
		{
			//afairei ton teleutaio iceskater apo tin stoiva kratontas ton se mia prosorini metavliti
            cout << "Deleting IceSkater " << lowerLeftStack.get_last_data()->get_id() << " from the LowerLeftStack" << endl;
			temp_icsk = lowerLeftStack.extract_from_end();
            temp_icsk->perform(); //epideiknyei tin deksiotita tou
            sk_num = temp_icsk->skate(length); //paei mexri to allo akro tis limnis kratontas ton arithmo olisthiseon
            cout << "Iceskater " << temp_icsk->get_id() <<
                    " with color " << (temp_icsk->get_color() == 0? "black" : "white") <<
                    " skated " << sk_num << endl;
            delete temp_icsk; //sto telos ton diagrafei
			//an i lista meta tin teleutaia afairesi emeine keni auxanei to plithos ton kenon stoivon kata ena
            if (lowerLeftStack.is_empty())
            {
				empty++;
			}
		}
		if (!lowerRightStack.is_empty())
		{
            cout << "Deleting IceSkater " << lowerRightStack.get_last_data()->get_id() << " from the LowerRightStack" << endl;
            temp_icsk = lowerRightStack.extract_from_end();
            temp_icsk->perform();
            sk_num = temp_icsk->skate(length);
            cout << "Iceskater " << temp_icsk->get_id() <<
                    " with color " << (temp_icsk->get_color() == 0? "black" : "white") <<
                    " skated " << sk_num << endl;
            delete temp_icsk;
            if (lowerRightStack.is_empty())
            {
				empty++;
			}
		}
		if (!upperRightStack.is_empty())
		{
            cout << "Deleting IceSkater " << upperRightStack.get_last_data()->get_id() << " from the UpperRightStack" << endl;
			temp_icsk = upperRightStack.extract_from_end();
            temp_icsk->perform();
            sk_num = temp_icsk->skate(length);
            cout << "Iceskater " << temp_icsk->get_id() <<
                    " with color " << (temp_icsk->get_color() == 0? "black" : "white") <<
                    " skated " << sk_num << endl;
            delete temp_icsk;
            if (upperRightStack.is_empty())
            {
				empty++;
			}
		}
		if (!upperLeftStack.is_empty())
		{
            cout << "Deleting IceSkater " << upperLeftStack.get_last_data()->get_id() << " from the UpperLeftStack" << endl;
			temp_icsk = upperLeftStack.extract_from_end();
            temp_icsk->perform();
            sk_num = temp_icsk->skate(length);
            cout << "Iceskater " << temp_icsk->get_id() <<
                    " with color " << (temp_icsk->get_color() == 0? "black" : "white") <<
                    " skated " << sk_num << endl;
            delete temp_icsk;
            if (upperLeftStack.is_empty())
            {
				empty++;
			}
		}
	}
	temp_icsk = NULL;
}
