/*Filename: list.cpp*/

#include <iostream>
#include "list.h"

using namespace std;

List::List()
{
	first = last = NULL;
	size = 0;
}

List::~List()
{
	while(!is_empty())
	{
		delete extract_from_start();
	}
}

bool List::is_empty()
{
	if(size == 0 && first == NULL && last == NULL)
	{
		return true;
	}
	else
	{
		return false;
	}
}

int List::get_size()
{
	return size;
}

void List::insert_at_end(ListContent *data) /*eisagogi sto telos*/
{
	if (is_empty()) /*an lista keni*/
	{ 
	    first = new ListNode(data); /*desmeuei ena komvo kai arxikopoei tous deiktes na deixnoun se auton*/
	    last = first;
	    size++;  /*auxanei to mikos tis listas kata ena*/
    }
    else /*an i lista den einai keni*/
    {
	    last->set_next(new ListNode(data)); /*desmeuei ton kainourio teleutaio komvo*/
	    last->get_next()->set_prev(last); /*arxikopoiei ton deikti proigoumenos na deixnei ston palio Last*/
	    last = last->get_next(); /*allazei ton deikti Last na deixnei se auton*/
		size++;  /*auxanei to mikos tis listas kata ena*/
	}
}

void List::insert_at_start(ListContent* data) /*eisagogi stin arxi*/
{
	if (is_empty()) /*an lista keni*/
	{
	    first = new ListNode(data); /*desmeuei ena komvo kai arxikopoei tous deiktes na deixnoun se auton*/
	    last = first;
	    size++;  /*auxanei to mikos tis listas kata ena*/
    }
    else /*an i lista den einai keni*/
    {
	    first->set_prev(new ListNode(data)); /*desmeuei ton kainourio proto komvo*/
	    first->get_prev()->set_next(first); /*arxikopoiei ton deikti epomenos na deixnei ston palio First*/
	    first = first->get_prev(); /*allazei ton deikti First na deixnei se auton*/
		size++;  /*auxanei to mikos tis listas kata ena*/
	}
}

ListContent* List::extract_from_start() /*exagogi apo arxi*/
{
	ListContent *data;
	if (size != 1)/*an i lista exei perissoterous apo ena komvo*/
	{
		first = first->get_next(); /*allazei to deikti First na deixnei ston epomeno*/
		data = first->get_prev()->get_data();
		delete first->get_prev(); /*apodesmeuei ton palio proto komvo*/
		first->set_prev(NULL); /*allazei ton deikti proigoumenos tou protou komvou na einai NULL*/
		size--;  /*meionei to mikos tis listas kata ena*/
    }
	else /*an i lista exei mono ena komvo*/
	{
		data = first->get_data(); 
		delete first; /*apodesmeuei ton monadiko komvo*/
		first = NULL;   /*allazei tous deiktes se NULL*/
		last = NULL;
		size = 0;  /*allagi mikous listas se miden*/
	}
	return data;
}


ListContent* List::extract_from_end()
{
	ListContent *data;
	if (size != 1)/*an i lista exei perissoterous apo ena komvo*/
	{
		last = last->get_prev(); /*allazei to deikti Last na deixnei ston proigoumeno*/
		data = last->get_next()->get_data();
		delete last->get_next(); /*apodesmeuei ton palio teleutaio komvo*/
		last->set_next(NULL); /*allazei ton deikti epomenos tou teleutaiou komvou na einai NULL*/
		size--;  /*meionei to mikos tis listas kata ena*/
    }
	else /*an i lista exei mono ena komvo*/
	{
		data = first->get_data();
		delete first; /*apodesmeuei ton monadiko komvo*/
		first = NULL;   /*allazei tous deiktes se NULL*/
		last = NULL;
		size = 0;  /*allagi mikous listas se miden*/
	}
	return data;
}


ListContent* List::get_first_data()
{
	return first->get_data();
}

ListContent* List::get_last_data()
{
    return last->get_data();
}
