/*Filename: scene.cpp*/

#include <iostream>
#include "scene.h"

using namespace std;

Scene::Scene(const int length, const int num):lake(length)
{
	icesk_num = num;
}

void Scene::preparation()
{
    IceSkater* icsk;
    int distance, color, black = 0, white = 0;
    
    cout << "\nAdding Iceskaters to the queues...\n" << endl;

	for (int i = 0; i < icesk_num; i++)
	{
		distance = rand() % (lake.get_length()-1) + 1;
		
		//an to plithos ton iceskaters perito kai exei ftasei ston teleutaio
		if (icesk_num % 2 == 1 && i == icesk_num - 1) 
		{
			//thetei to xroma tou antitheto apo tou teleutaiou
			if (main_queue.get_last_data()->get_color() == 0)
			{
	            color = 1;
			}
			else
			{
	            color = 0;
			}
		}
		//an symplirothikan oi mauroi
		else if (black == icesk_num/2)
		{
			color = 1;
		}
		//an symplirothikan oi asproi
		else if (white == icesk_num/2)
		{
			color = 0;
		}
		else
		{
			color = rand() % 2;
			
			if (color == 0)
			{
				black++;
			}
			else
			{
				white++;
			}
		}
		
        icsk = new IceSkater(distance, color);
        
        //an i vasiki oura einai keni i sto telos tis yparxei kapoios me diaforetiko xroma apo auton pou genithike
        if (main_queue.is_empty() || main_queue.get_last_data()->get_color() != color)
        {
			//ton topothetei stin vasiki oura
			cout << "Adding IceSkater " << icsk->get_id() << " to the MainQueue" << endl;
            main_queue.insert_at_end(icsk);
            
            //an i deutereuousa oura den einai keni kai to xroma autou pou molis mpike einai
            //diaforetiko apo to xroma tou protou stin deutereuousa oura
			if (!secondary_queue.is_empty()
			       && secondary_queue.get_first_data()->get_color() != main_queue.get_last_data()->get_color())
			{
				//metaferei ton proto apo tin deutereuousa oura stin vasiki
                cout << "Adding IceSkater " << secondary_queue.get_first_data()->get_id() << " to the MainQueue" << endl;
                cout << "Deleting IceSkater " << secondary_queue.get_first_data()->get_id() << " from the SecondaryQueue" << endl;
                main_queue.insert_at_end(secondary_queue.extract_from_start());
			}
		}
		else
		{
			//allios ton topothetei stin deutereousa oura
			cout << "Adding IceSkater " << icsk->get_id() << " to the SecondaryQueue" << endl;
            secondary_queue.insert_at_end(icsk);
		}
    }
}

void Scene::performance()
{
	//ksekinaei tin proetoimasia
	preparation();

    //ksekinaei tin parastasi sti limni
    lake.performance(main_queue);
}
